package com.taobao.idlefish.flutterboost;


import android.util.Log;

public class Debuger {
    private static final String TAG = "FlutterBoost#";
    private static final Debuger DEBUG = new Debuger();

    private Debuger(){ }

    private void print(String info) {
        if(isDebug()) {
            Log.e(TAG, info);
        }
    }

    public static void log(String info) {
        DEBUG.print(info);
    }

    public static void exception(String message) {
        if(isDebug()) {
            throw new RuntimeException(message);
        }else{
            Log.e(TAG,"exception",new RuntimeException(message));
        }
    }

    public static void exception(Throwable t) {
        if(isDebug()) {
            throw new RuntimeException(t);
        }else{
            Log.e(TAG,"exception",t);
        }
    }

    public static boolean isDebug(){
        try {
            return FlutterBoostPlugin.platform().isDebug();
        }catch (Throwable t){
            return false;
        }
    }
}
