package com.taobao.idlefish.flutterboost;

import com.taobao.idlefish.flutterboost.interfaces.IContainerRecord;
import com.taobao.idlefish.flutterboost.interfaces.IContainerManager;

public class Instrument {

    private final IContainerManager mManager;

    Instrument(IContainerManager manager) {
        mManager = manager;
    }

    public void performCreate(IContainerRecord record) {
        final int currentState = record.getState();
        if (currentState != IContainerRecord.STATE_UNKNOW) {
            Debuger.exception("performCreate state error, current state:" + currentState);
            return;
        }

        record.onCreate();
    }

    public void performAppear(IContainerRecord record) {
        final int currentState = record.getState();
        if (currentState != IContainerRecord.STATE_CREATED
                && currentState != IContainerRecord.STATE_DISAPPEAR) {
            Debuger.exception("performAppear state error, current state:" + currentState);
            return;
        }

        record.onAppear();
    }

    public void performDisappear(IContainerRecord record) {
        final int currentState = record.getState();
        if (currentState != IContainerRecord.STATE_APPEAR) {
            Debuger.exception("performDisappear state error , current state:" + currentState);
            return;
        }

        record.onDisappear();
    }

    public void performDestroy(IContainerRecord record) {
        final int currentState = record.getState();
        if (currentState != IContainerRecord.STATE_DISAPPEAR) {
            Debuger.exception("performDestroy state error, current state:" + currentState);
        }

        record.onDestroy();
    }
}
