//
//  FLBFlutterEngine.m
//  flutter_boost
//
//  Created by Jidong Chen on 2018/12/25.
//

#import "FLBFlutterEngine.h"
#import <Flutter/Flutter.h>
#import "FLBFlutterViewControllerAdaptor.h"

#if RELEASE_1_0

@interface FLBFlutterEngine()
@property (nonatomic,strong) FLBFlutterViewControllerAdaptor *viewController;
@property (nonatomic,strong) FlutterEngine *engine;
@end

@implementation FLBFlutterEngine

- (instancetype)init
{
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Warc-performSelector-leaks"
    
    if (self = [super init]) {
        _engine = [[FlutterEngine alloc] initWithName:@"io.flutter" project:nil];
        [_engine runWithEntrypoint:nil];
        _viewController = [[FLBFlutterViewControllerAdaptor alloc] initWithEngine:_engine
                                                                          nibName:nil
                                                                           bundle:nil];
        [_viewController view];
        Class clazz = NSClassFromString(@"GeneratedPluginRegistrant");
        if (clazz) {
            if ([clazz respondsToSelector:NSSelectorFromString(@"registerWithRegistry:")]) {
                [clazz performSelector:NSSelectorFromString(@"registerWithRegistry:")
                            withObject:_viewController];
            }
        }
    }
    
    return self;
#pragma clang diagnostic pop
}

- (FlutterViewController *)viewController
{
    return _viewController;
}

- (void)pause
{
    //TODO: [[_engine.get() lifecycleChannel] sendMessage:@"AppLifecycleState.paused"];
    [self.viewController boost_viewWillDisappear:NO];
    [self.viewController boost_viewDidDisappear:NO];
}

- (void)resume
{
    //TODO:   [[_engine.get() lifecycleChannel] sendMessage:@"AppLifecycleState.resumed"];
    [self.viewController boost_viewWillAppear:NO];
    [self.viewController boost_viewDidAppear:NO];
}

- (void)inactive
{
    [[_engine lifecycleChannel] sendMessage:@"AppLifecycleState.inactive"];
}

@end

#endif
