//
//  FLBFlutterViewProviderImp.m
//  flutter_boost
//
//  Created by Jidong Chen on 2018/12/17.
//

#import "FLBFlutterEngineOld.h"
#import "FLBFlutterViewControllerAdaptor.h"

@interface FLBFlutterEngineOld()
@property (nonatomic,strong) FLBFlutterViewControllerAdaptor *viewController;
@end

@implementation FLBFlutterEngineOld

- (instancetype)init
{
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Warc-performSelector-leaks"
    
    if (self = [super init]) {
        _viewController = [FLBFlutterViewControllerAdaptor new];
        [_viewController view];
        Class clazz = NSClassFromString(@"GeneratedPluginRegistrant");
        if (clazz) {
            if ([clazz respondsToSelector:NSSelectorFromString(@"registerWithRegistry:")]) {
                [clazz performSelector:NSSelectorFromString(@"registerWithRegistry:")
                            withObject:_viewController];
            }
        }
    }
    
    return self;
#pragma clang diagnostic pop
}

- (FlutterViewController *)viewController
{
    return _viewController;
}

- (void)pause
{
    [self.viewController boost_viewWillDisappear:NO];
    [self.viewController boost_viewDidDisappear:NO];
}

- (void)resume
{
    [self.viewController boost_viewWillAppear:NO];
    [self.viewController boost_viewDidAppear:NO];
}

- (void)inactive
{
    NSString *channel = @"flutter/lifecycle";
    NSString *message = @"AppLifecycleState.inactive";
    NSData *data = [[FlutterStringCodec sharedInstance] encode:message];
    [self.viewController sendOnChannel:channel message:data];
}

- (void)resumeFlutterOnly
{
    NSString *channel = @"flutter/lifecycle";
    NSString *message = @"AppLifecycleState.resumed";
    NSData *data = [[FlutterStringCodec sharedInstance] encode:message];
    [self.viewController sendOnChannel:channel message:data];
}

@end
