//
//  FLBFlutterApplication.h
//  flutter_boost
//
//  Created by Jidong Chen on 2018/10/16.
//

#import <Foundation/Foundation.h>
#import <Flutter/Flutter.h>
#import "FLBPlatform.h"
#import "FlutterBoost.h"

NS_ASSUME_NONNULL_BEGIN
@interface FLBFlutterApplication : NSObject

@property (nonatomic,strong) id<FLBPlatform> platform;

#pragma mark - Getters
+ (FLBFlutterApplication *)sharedApplication;
- (void)startFlutterWithPlatform:(id<FLBPlatform>)platform
                         onStart:(void (^)(FlutterViewController *))callback;
- (FlutterViewController *)flutterViewController;

#pragma mark - Container Management
- (BOOL)contains:(FLBFlutterViewContainer  *)vc;
- (void)addUniqueViewController:(FLBFlutterViewContainer  *)vc;
- (void)removeViewController:(FLBFlutterViewContainer  *)vc;
- (BOOL)isTop:(NSString *)pageId;

#pragma mark - App Control
- (void)pause;
- (void)resume;
- (void)inactive;
- (BOOL)isRunning;
@end

NS_ASSUME_NONNULL_END
