//
//  FLBResultMediator.m
//  flutter_boost
//
//  Created by Jidong Chen on 2018/12/27.
//

#import "FLBResultMediator.h"

@interface FLBResultMediator()
@property (nonatomic,strong) NSMutableDictionary *handlers;
@end

@implementation FLBResultMediator

- (instancetype)init
{
    if (self = [super init]) {
        _handlers = [NSMutableDictionary new];
    }
    return self;
}

- (void)onResultForKey:(NSString *)vcId
            resultData:(NSDictionary *)resultData
{
    if(!vcId) return;
    
    NSString *key = vcId;
    if(_handlers[key]){
        FLBPageResultHandler handler = _handlers[key];
        handler(key,resultData);
        [_handlers removeObjectForKey: key];
    }
}

- (void)setResultHandler:(FLBPageResultHandler)handler
                  forKey:(NSString *)vcid
{
    if(!handler || !vcid) return;
    _handlers[vcid] = handler;
}

- (void)removeHandlerForKey:(NSString *)vcid
{
    if(!vcid) return;
    [_handlers removeObjectForKey:vcid];
}

@end
