//
//  FLBFlutterViewControllerStack.m
//  flutter_boost
//
//  Created by Jidong Chen on 2018/10/17.
//

#import "FLBFlutterViewContainerManager.h"

@interface FLBFlutterViewContainerManager()
@property (nonatomic,strong) NSMutableArray *idStk;
@property (nonatomic,strong) NSMutableDictionary *existedID;
@end

@implementation FLBFlutterViewContainerManager

- (instancetype)init
{
    if (self = [super init]) {
        _idStk= [NSMutableArray new];
        _existedID = [NSMutableDictionary dictionary];
    }
    
    return self;
}

- (BOOL)contains:(FLBFlutterViewContainer  *)vc
{
    if (vc) {
        return _existedID[vc.uniqueIDString]?YES:NO;
    }
    
    return NO;
}

- (void)addUnique:(FLBFlutterViewContainer  *)vc
{
    if (vc) {
        if(!_existedID[vc.uniqueIDString]){
            [_idStk addObject:vc.uniqueIDString];
        }
        _existedID[vc.uniqueIDString] = vc.uniqueIDString;
    }
}

- (void)remove:(FLBFlutterViewContainer  *)vc
{
    if (vc) {
        [_existedID removeObjectForKey:vc.uniqueIDString];
        [_idStk removeObject:vc.uniqueIDString];
    }
}

- (NSString *)peak
{
    return _idStk.lastObject;
}

@end
