//
//  FLBStackCache
//  flutter_chann_plugin
//
//  Created by Jidong Chen on 2018/8/2.
//

#import <Foundation/Foundation.h>

@class FLBStackCache;

@protocol FLBStackCacheObject<NSObject>

@required
@property (nonatomic,copy) NSString *key;

- (BOOL)writeToFileWithKey:(NSString *)key
                     queue:(dispatch_queue_t)queue
                     cache:(FLBStackCache *)cache
                completion:(void (^)(NSError *err,NSString *path))completion;

+ (BOOL)loadFromFileWithKey:(NSString *)key
                      queue:(dispatch_queue_t)queue
                     cache:(FLBStackCache *)cache
                 completion:(void (^)(NSError *err ,id<FLBStackCacheObject>))completion;

@end


@interface FLBStackCache : NSObject
+ (instancetype)sharedInstance;

/**
 * Num of objects allowed in memory.
 * Default value is set to 2.
 */
@property (nonatomic,assign) NSUInteger inMemoryCount;

#pragma mark - basic operations.
- (void)pushObject:(id<FLBStackCacheObject>)obj key:(NSString *)key;
- (id<FLBStackCacheObject>)remove:(NSString *)key;
- (BOOL)empty;
- (void)clear;
- (id<FLBStackCacheObject>)objectForKey:(NSString *)key;

#pragma mark - Disk thing.
- (NSString *)cacheDir;
@end
