import 'dart:async';

import 'package:flutter/services.dart';
import 'package:xservice_kit/ServiceCallHandler.dart';
import 'package:xservice_kit/ServiceGateway.dart';
import 'package:flutter_boost/container/container_coordinator.dart';

class NavigationService_didInitPageContainer extends ServiceCallHandler {
  static void regsiter() {
    ServiceGateway.sharedInstance()
        .registerHandler(new NavigationService_didInitPageContainer());
  }

  @override
  String name() {
    return "didInitPageContainer";
  }

  @override
  String service() {
    return "NavigationService";
  }

  @override
  Future<bool> onMethodCall(MethodCall call) {
    return onCall(call.arguments["pageName"], call.arguments["params"],
        call.arguments["uniqueId"]);
  }

//==============================================Do not edit code above!

  Future<bool> onCall(String pageName, Map params, String uniqueId) async {
    return ContainerCoordinator.singleton
        .nativeContainerDidInit(pageName, params, uniqueId);
  }
}
