/**
 * Created by Jidong Chen on 2018/12/26.
 */

import 'package:flutter/widgets.dart';
import 'package:flutter/material.dart';

typedef Widget PageBuilder(String pageName, Map params, String uniqueId);

class BoostPageRoute<T> extends MaterialPageRoute<T> {
  final String pageName;
  final String uniqueId;
  final Map params;
  final bool animated;
  final WidgetBuilder builder;
  final RouteSettings settings;

  final Set<VoidCallback> backPressedListeners = Set<VoidCallback>();

  @override
  Widget buildTransitions(BuildContext context, Animation<double> animation,
      Animation<double> secondaryAnimation, Widget child) {
    return child;
  }

  BoostPageRoute(
      {Key stubKey,
      this.pageName,
      this.params,
      this.uniqueId,
      this.animated,
      this.builder,
      this.settings})
      : super(
            builder: (BuildContext context) => Stub(stubKey,builder(context)),
            settings: settings);

  static BoostPageRoute<T> of<T>(BuildContext context) {
    final Route<T> route = ModalRoute.of(context);
    if (route != null && route is BoostPageRoute<T>) {
      return route;
    } else {
      throw Exception('not in a BoostPageRoute');
    }
  }

  static BoostPageRoute<T> tryOf<T>(BuildContext context) {
    final Route<T> route = ModalRoute.of(context);
    if (route != null && route is BoostPageRoute<T>) {
      return route;
    } else {
      return null;
    }
  }
}

@immutable
class Stub extends StatefulWidget {
  final Widget child;

  const Stub(Key key,this.child):super(key:key);

  @override
  _StubState createState() => _StubState();
}

class _StubState extends State<Stub> {
  @override
  Widget build(BuildContext context) => widget.child;
}
